<template>
  <div class="module module-kontakt-mit-personen row">
    <div class="col col-12 col-lg-5 offset-lg-1">
      <h2 v-if="data.headline" class="h3" v-html="$stripPTags(data.headline)" />
      <div v-if="data.text" class="text" v-html="data.text" />
      <nuxt-link :to="kontaktlinkUrl" class="kontaktlink">{{
        data.kontaktlinkText
      }}</nuxt-link>
    </div>
    <div class="col col-12 col-lg-6">
      <div v-if="$mq === 'xs' || $mq === 'sm'">
        <atom-slider
          ref="flickity"
          class="main-carousel flickity"
          :options="flickityOptions"
        >
          <div
            v-for="(person, index) in data.personen"
            :key="index"
            class="carousel-cell slide"
          >
            <div class="text-wrapper">
              <div class="d-block position-relative">
                <div class="card-holder card-holder-slider">
                  <atom-contact-card v-if="person" :data="person" />
                </div>
              </div>
            </div>
          </div>
        </atom-slider>
        <div v-if="$mq === 'xs' || $mq === 'sm'" class="flickity-mobile-controls">
          <button
            class="flickity-button flickity-prev-next-button previous"
            type="button" aria-label="Previous"
            @click="$refs.flickity.previous()"
          >
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
              <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
            </svg>
          </button>
          <ol class="flickity-page-dots">
            <li
              v-for="(slide, index) in data.personen"
              :key="index"
              class="dot"
              :class="{ 'is-selected': selectedSlide === index }"
              @click="$refs.flickity.select(index)"
            ></li>
          </ol>
          <button
            class="flickity-button flickity-prev-next-button next"
            type="button" aria-label="Next"
            @click="$refs.flickity.next()"
          >
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
              <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
            </svg>
          </button>
        </div>
      </div>
      <div v-else>
        <div class="row">
          <div
            v-for="(person, index) in data.personen"
            :key="index"
            class="col col-12 col-md-5 col-lg-6"
            :class="{ 'offset-md-1 offset-lg-0' : index === 0 }"
          >
            <div class="card-holder">
              <atom-contact-card v-if="person" :data="person" />
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props: {
    data: {
      type:Object,
      default: () => {},
    }
  },
  data() {
    return {
      selectedSlide: 0,
      flickityOptions: {
          wrapAround: true,
          cellAlign: 'left',
          autoPlay: false,
          draggable: true,
          contain: true,
          selectedAttraction: 0.025,
          friction: 0.3,
          prevNextButtons: false,
          pageDots: false,
          arrowShape: 'M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z',
          adaptiveHeight: true,
          imagesLoaded: true,
          // any options from Flickity can be used
      },
    };
  },
  computed: {
    kontaktlinkUrl() {
      return this.data.kontaktlinkUrl ? this.data.kontaktlinkUrl.url : '/kontakt';
    },
  },
  mounted() {
    this.$nextTick(() => {
      this.$nextTick(() => {
        if (this.$refs.flickity) {
          this.$refs.flickity.on('change', (index) => {
            this.selectedSlide = index;
          });
        }
      });
    });
  },
}
</script>

<style lang="scss" scoped>
.module-kontakt-mit-personen {
  .text {
    max-width: 450px;
    margin-bottom: 2.5rem;
  }

  .kontaktlink {
    display: block;
    letter-spacing: 1px;
    font-weight: 600;
    text-transform: uppercase;
    margin-bottom: 2.5rem;
  }

  .card-holder {
    margin: 0 -1rem;

    @include media-breakpoint-up(lg) {
      margin: 0;
    }
  }

  .card-holder-slider {
    margin: 0;

    &::v-deep .atom-contact-card {
      margin: 0 !important;
      width: calc(100% - 0.625rem);
    }
  }

  .flickity-mobile-controls {
    @include media-breakpoint-up(md) {
      display: flex;
    }
    @include media-breakpoint-up(lg) {
      display: none;
    }
  }

  .flickity-viewport {
    transition: height 0.35s;
  }

  .flickity-page-dots {
    display: block;
  }
}
</style>
